glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::UnixFDList Class Reference
Portable Network I/O Functionality

UnixFDList - An object containing a set of UNIX file descriptors. More...

`#include <giomm/unixfdlist.h>`

Inheritance diagram for Gio::UnixFDList:
[legend]

## Public Member Functions
| UnixFDList (UnixFDList&& src) noexcept
UnixFDList& | operator= (UnixFDList&& src) noexcept
| ~UnixFDList () noexcept override
GUnixFDList* | gobj ()
| Provides access to the underlying C GObject. More...
const GUnixFDList* | gobj () const
| Provides access to the underlying C GObject. More...
GUnixFDList* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
int | get_length () const
| Gets the length of list (ie: the number of file descriptors contained within). More...
int | get (int index) const
| Gets a file descriptor out of list. More...
const Glib::ArrayHandle< int > | peek_fds () const
| Returns the array of file descriptors that is contained in this object. More...
Glib::ArrayHandle< int > | steal_fds ()
| Returns the array of file descriptors that is contained in this object. More...
int | append (int fd)
| Adds a file descriptor to list. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< UnixFDList > | create ()
| Creates a new UnixFDList containing no file descriptors. More...
static Glib::RefPtr< UnixFDList > | create (const Glib::ArrayHandle< int >& fds)
| Creates a new UnixFDList containing the file descriptors given in fds. More...
static Glib::RefPtr< UnixFDList > | create (const Glib::ArrayHandle< int >& fds, int n_fds)
| Creates a new UnixFDList containing the file descriptors given in fds. More...

## Protected Member Functions
| UnixFDList ()
| UnixFDList (const Glib::ArrayHandle< int >& fds)
| UnixFDList (const Glib::ArrayHandle< int >& fds, int n_fds)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixFDList > | wrap (GUnixFDList* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

UnixFDList - An object containing a set of UNIX file descriptors.

A UnixFDList contains a list of file descriptors. It owns the file descriptors that it contains, closing them when finalized.

It may be wrapped in a UnixFDMessage and sent over a Socket in the G_SOCKET_ADDRESS_UNIX family by using Gio::Socket::send() and received using Gio::Socket::receive().

Since glibmm 2.28:

## Constructor & Destructor Documentation

## ◆ UnixFDList() [1/4]

Gio::UnixFDList::UnixFDList | ( | UnixFDList&& | src | ) |
| noexcept

## ◆ ~UnixFDList()

Gio::UnixFDList::~UnixFDList | ( |  | ) |
| override noexcept

## ◆ UnixFDList() [2/4]

Gio::UnixFDList::UnixFDList | ( |  | ) |
| protected

## ◆ UnixFDList() [3/4]

Gio::UnixFDList::UnixFDList | ( | const Glib::ArrayHandle< int >& | fds | ) |
| explicit protected

## ◆ UnixFDList() [4/4]

Gio::UnixFDList::UnixFDList | ( | const Glib::ArrayHandle< int >& | fds,
|  | int | n_fds
| ) |  |
| explicit protected

## Member Function Documentation

## ◆ append()

int Gio::UnixFDList::append | ( | int | fd | ) |

Adds a file descriptor to list.

The file descriptor is duplicated using dup(). You keep your copy of the descriptor and the copy contained in list will be closed when list is finalized.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

The index of the file descriptor in the list is returned. If you use this index with g_unix_fd_list_get() then you will receive back a duplicated copy of the same file descriptor.

Since glibmm 2.24:

Parameters

  fd | A valid open file descriptor.

Returns
  The index of the appended fd in case of success, else -1 (and error is set).

Exceptions

  Glib::Error. |

## ◆ create() [1/3]

static Glib::RefPtr<UnixFDList> Gio::UnixFDList::create | ( |  | ) |
| static

Creates a new UnixFDList containing no file descriptors.

Since glibmm 2.24:

Returns
  A new UnixFDList.

## ◆ create() [2/3]

static Glib::RefPtr<UnixFDList> Gio::UnixFDList::create | ( | const Glib::ArrayHandle< int >& | fds | ) |
| static

Creates a new UnixFDList containing the file descriptors given in fds.

The file descriptors become the property of the new list and may no longer be used by the caller. The array itself is owned by the caller.

Each file descriptor in the array should be set to close-on-exec.

Parameters

  fds | The list of file descriptors to use for creation.

Returns
  A new UnixFDList.

## ◆ create() [3/3]

static Glib::RefPtr<UnixFDList> Gio::UnixFDList::create | ( | const Glib::ArrayHandle< int >& | fds,
|  | int | n_fds
| ) |  |
| static

Creates a new UnixFDList containing the file descriptors given in fds.

The file descriptors become the property of the new list and may no longer be used by the caller. The array itself is owned by the caller.

Each file descriptor in the array should be set to close-on-exec.

If n_fds is -1 then fds must be terminated with -1.

Since glibmm 2.24:

Parameters

  fds | The initial list of file descriptors.
  n_fds | The length of #fds, or -1.

Returns
  A new UnixFDList.

## ◆ get()

int Gio::UnixFDList::get | ( | int | index | ) | const

Gets a file descriptor out of list.

index specifies the index of the file descriptor to get. It is a programmer error for index to be out of range; see g_unix_fd_list_get_length().

The file descriptor is duplicated using dup() and set as close-on-exec before being returned. You must call close() on it when you are done.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

Since glibmm 2.24:

Parameters

  index | The index into the list.

Returns
  The file descriptor, or -1 in case of error.

Exceptions

  Glib::Error |

## ◆ get_length()

int Gio::UnixFDList::get_length | ( |  | ) | const

Gets the length of list (ie: the number of file descriptors contained within).

Since glibmm 2.24:

Returns
  The length of list.

## ◆ get_type()

static GType Gio::UnixFDList::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GUnixFDList* Gio::UnixFDList::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GUnixFDList* Gio::UnixFDList::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GUnixFDList* Gio::UnixFDList::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

UnixFDList& Gio::UnixFDList::operator= | ( | UnixFDList&& | src | ) |
| noexcept

## ◆ peek_fds()

const Glib::ArrayHandle<int> Gio::UnixFDList::peek_fds | ( |  | ) | const

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors remain the property of the list. The caller must not close them. The array is valid only until list is changed in any way.

Returns
  The list of file descriptors.

Since glibmm 2.28:

## ◆ steal_fds()

Glib::ArrayHandle<int> Gio::UnixFDList::steal_fds | ( |  | ) |

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors are no longer contained in the list. Further calls will return an empty list (unless more descriptors have been added).

The caller is responsible for closing all of the file descriptors. The file descriptors in the array are set to close-on-exec.

Returns
  The list of file descriptors.

Since glibmm 2.28:

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::UnixFDList > wrap | ( | GUnixFDList * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.